##
## ---------------- bin500 VM disassembler -------------------
##
import idaapi,idc
import binascii

def PathMem(ea,buf):
  i = 0
  for c in buf:
    PatchByte(ea+i,ord(c))
    i += 1

def GetMem(ea,size):
  r = ''
  for ea in range(ea,ea+size):
    r += chr(Byte(ea))
  return r

def b500_decode(data, length, key):
 decode_f = Appcall.proto("decode_buffer", "void __stdcall decode_buffer(char *a1, int a2, int a3);")
 buf = Appcall.buffer(data)
 decode_f(buf, length, key)
 return buf.value

op_xtable = "\x2D\xEC\x43\x8D\x73\x61\xE1\xF2\xC0\x47\x0E\x15\x97\x3D\xF4\x49" \
"\x93\xC9\x17\xCA\x8A\xB2\x30\x45\x07\xAA\x38\x9B\xFB\xC3\xE3\xAF" \
"\xB5\x8F\xAE\xFD\xFE\x5D\x8E\xFF\xD9\x89\xB3\x94\x59\x29\xFA\xBE" \
"\x0C\x27\xED\x5E\xDF\x79\x7F\x9D\x9E\xBC\x6D\xAB\xE6\x41\xBA\x3B" \
"\x9A\x09\x84\x68\xAD\x3C\xEA\x82\x2C\xEE\x35\xA5\xB9\xC5\x76\xD4" \
"\x1A\xD3\xEF\x52\xA9\x31\x24\x14\x96\xE9\x0F\xA0\xE0\xF9\x0D\xE5" \
"\x8C\x7C\x64\x1B\x18\xD8\xCF\x39\xF0\x58\xC1\x5C\x32\x85\xB8\x86" \
"\x1D\x2E\xD2\xB4\x4E\x25\x54\xDE\x66\xB7\xB0\x28\xE7\x62\x95\xD5" \
"\x37\x2B\x10\xCC\x4D\x92\x04\x60\x21\x56\xBB\xA8\xB1\x98\x87\x33" \
"\x70\x4C\x44\xF1\xD7\xDA\x4A\x71\x08\x3E\xF7\x69\xA3\xC6\x0B\x01" \
"\xD1\xA4\x91\xDB\x20\x7E\x7B\x40\x57\x8B\x42\x05\x6A\xF5\xBF\x19" \
"\x0A\x23\x1C\x63\x3F\xC2\xA6\x7A\xD6\x75\x81\x53\xA1\x88\x1E\x4B" \
"\xD0\x36\x02\x4F\xCB\x6F\xC7\x5A\xEB\x26\xF3\x48\xC8\xB6\x7D\x6C" \
"\x46\xF8\x83\xC4\x1F\x06\x5F\x80\xCD\xA7\x34\xBD\x3A\xE8\x65\xE4" \
"\x22\x74\x78\x16\x00\xAC\x5B\x2A\xDD\x13\x72\x55\xDC\x03\xE2\xFC" \
"\x67\x90\xA2\xCE\x2F\x12\x6B\x9F\x99\x11\x9C\x50\x77\x51\x6E\xF6"

def VMBlockDisasm(buf,max_len = 200):
  print "---[ Disassemble block %x " % buf
  PC = 0
  while( PC<max_len):
    l = Byte(buf+PC)^Byte(buf+PC+1)
    d = GetMem(buf+PC+1,l)
    (s,op,d) = VmDiasm( b500_decode(d,l,PC) )
    print PC,l,s,hex(op),d
    #if( op in [3,4,5] ): break
    PC += l+1
    
def VmDiasm(d):
  if d[:2] == '\xFF\xFF':
    return ("[VM] ",ord(op_xtable[ord(d[2])]),binascii.b2a_hex(d[3:]))
  else:
    return ("[native] ",0,binascii.b2a_hex(d))

VMBlockDisasm(0x413b79,119)
VMBlockDisasm(0x413c15,175)
VMBlockDisasm(0x413ce7,89)
VMBlockDisasm(0x413d63,83)
VMBlockDisasm(0x413dd9,67)
VMBlockDisasm(0x413e3f,92)
VMBlockDisasm(0x413ebe,47)
VMBlockDisasm(0x413f10,160)
VMBlockDisasm(0x413FD5,55)
VMBlockDisasm(0x41402F,55)
VMBlockDisasm(0x414089,118)
VMBlockDisasm(0x414122,210)
VMBlockDisasm(0x414217,112)
VMBlockDisasm(0x4142AA,119)
VMBlockDisasm(0x414344,70)
VMBlockDisasm(0x4143ad,71)
VMBlockDisasm(0x414417,84)
VMBlockDisasm(0x41448E,62)
VMBlockDisasm(0x4144ef,104)
VMBlockDisasm(0x41457a,72)
VMBlockDisasm(0x04145E5,69)
VMBlockDisasm(0x4145e5,69)
VMBlockDisasm(0x41464d,98)

